/* ircd_client.c - NextIRCd
 * Copyright (C) 2012-2013  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "ircd_client.h"
#include "ircd_sock.h"
#include "struct_connection.h"
#include "struct_auth.h"
#include "ircd_config.h"
#include "version.h"

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#define CLIENT_MAXLEN 512

static void client_printf(struct Connection *conn, const char *text, ...) {
    va_list arg_list;
	char sendBuf[CLIENT_MAXLEN];
	int pos;
	sendBuf[0] = '\0';
	va_start(arg_list, text);
	pos = vsnprintf(sendBuf, CLIENT_MAXLEN - 2, text, arg_list);
	va_end(arg_list);
	if (pos < 0 || pos > (CLIENT_MAXLEN - 2)) pos = CLIENT_MAXLEN - 2;
	sendBuf[pos] = '\n';
    sendBuf[pos+1] = '\0';
	socket_send(conn, sendBuf, pos+1);
}

void client_connected(struct Connection *conn) {
    client_printf(conn, "NOTICE AUTH :*** NextIRCd v%d.%d (%s)", VERSION_NUMBER, patchlevel, revision);
    
    struct Auth *auth = calloc(1, sizeof(*auth));
    auth->conn = conn;
    conn->data.auth = auth;
    
    /* maybe do some stuff here? */
}

void client_disconnected(struct Connection *conn) {
    
}

void client_recv(struct Connection *conn, char *line) {
    
}
